searchNodes=[{"doc":"Nebulex adapter for Redis. This adapter is implemented using Redix , a Redis driver for Elixir. NebulexRedisAdapter provides three setup alternatives: Standalone - The adapter establishes a pool of connections with a single Redis node. The :standalone is the default mode. Redis Cluster - Redis Cluster is a built-in feature in Redis since version 3, and it may be the most convenient and recommendable way to set up Redis in a cluster and have a distributed cache storage out-of-box. This adapter provides the :redis_cluster mode to set up Redis Cluster from the client-side automatically and be able to use it transparently. Built-in client-side cluster based on sharding - This adapter provides a simple client-side cluster implementation based on Sharding distribution model via :client_side_cluster mode. Standalone We can define a cache to use Redis as follows: defmodule MyApp.RedisCache do use Nebulex.Cache , otp_app : :nebulex , adapter : NebulexRedisAdapter end The configuration for the cache must be in your application environment, usually defined in your config/config.exs : config :my_app , MyApp.RedisCache , conn_opts : [ host : &quot;127.0.0.1&quot; , port : 6379 ] Redis Cluster We can define a cache to use Redis Cluster as follows: defmodule MyApp.RedisClusterCache do use Nebulex.Cache , otp_app : :nebulex , adapter : NebulexRedisAdapter end The config: config :my_app , MyApp.RedisClusterCache , mode : :redis_cluster , redis_cluster : [ configuration_endpoints : [ endpoint1_conn_opts : [ host : &quot;127.0.0.1&quot; , port : 6379 , # Add the password if &#39;requirepass&#39; is on password : &quot;password&quot; ] , ... ] ] Client-side Cluster We can define a cache with &quot;client-side cluster mode&quot; as follows: defmodule MyApp.ClusteredCache do use Nebulex.Cache , otp_app : :nebulex , adapter : NebulexRedisAdapter end The config: config :my_app , MyApp.ClusteredCache , mode : :client_side_cluster , client_side_cluster : [ nodes : [ node1 : [ pool_size : 10 , conn_opts : [ host : &quot;127.0.0.1&quot; , port : 9001 ] ] , node2 : [ pool_size : 4 , conn_opts : [ url : &quot;redis://127.0.0.1:9002&quot; ] ] , node3 : [ conn_opts : [ host : &quot;127.0.0.1&quot; , port : 9003 ] ] , ... ] ] Configuration options In addition to Nebulex.Cache config options, the adapter supports the following options: :mode - Redis configuration mode. :standalone - A single Redis instance. See the &quot;Standalone&quot; section in the module documentation for more options. :redis_cluster - Redis Cluster setup. See the &quot;Redis Cluster&quot; section in the module documentation for more options. :client_side_cluster - See the &quot;Client-side Cluster&quot; section in the module documentation for more options. The default value is :standalone . :pool_size ( pos_integer/0 ) - The number of connections that will be started by the adapter (based on the :mode ). The default value is System.schedulers_online() . :serializer - Custom serializer module implementing the NebulexRedisAdapter.Serializer behaviour. :serializer_opts ( keyword/0 ) - Custom serializer options. The default value is [] . :encode_key ( keyword/0 ) - Options for encoding the key. The default value is [] . :encode_value ( keyword/0 ) - Options for encoding the value. The default value is [] . :decode_key ( keyword/0 ) - Options for decoding the key. The default value is [] . :decode_value ( keyword/0 ) - Options for decoding the value. The default value is [] . :conn_opts ( keyword/0 ) - Redis client options. See Redix docs for more information about the options. The default value is [host: &quot;127.0.0.1&quot;, port: 6379] . :redis_cluster - Required only when :mode is set to :redis_cluster . A keyword list of options. See &quot;Redis Cluster options&quot; section below. :client_side_cluster - Required only when :mode is set to :client_side_cluster . A keyword list of options. See &quot;Client-side Cluster options&quot; section below. Redis Cluster options The available options are: :configuration_endpoints - Required. A keyword list of named endpoints where the key is an atom as an identifier and the value is another keyword list of options (same as :conn_opts ). See &quot;Redis Cluster&quot; for more information. :override_master_host ( boolean/0 ) - Defines whether the given master host should be overridden with the configuration endpoint or not. Defaults to false . The adapter uses the host returned by the &quot;CLUSTER SHARDS&quot; (Redis &gt;= 7) or &quot;CLUSTER SLOTS&quot; (Redis &lt; 7) command. One may consider set it to true for tests when using Docker for example, or when Redis nodes are behind a load balancer that Redis doesn't know the endpoint of. See Redis docs for more information. The default value is false . :keyslot - The module implementing the Nebulex.Adapter.Keyslot behaviour, which is used to compute the node where the command will be applied to. The default value is NebulexRedisAdapter.RedisCluster.Keyslot . Client-side Cluster options The available options are: :nodes - Required. A keyword list of named nodes where the key is an atom as an identifier and the value is another keyword list of options (same as :conn_opts ). See &quot;Client-side Cluster&quot; for more information. :keyslot - The module implementing the Nebulex.Adapter.Keyslot behaviour, which is used to compute the node where the command will be applied to. The default value is NebulexRedisAdapter.ClientCluster.Keyslot . Shared runtime options Since the adapter runs on top of Redix , all commands accept their options (e.g.: :timeout , and :telemetry_metadata ). See Redix docs for more information. Redis Cluster runtime options The following options apply to all commands: :lock_retries - This option is specific to the :redis_cluster mode. When the config manager is running and setting up the hash slot map, all Redis commands get blocked until the cluster is properly configured and the hash slot map is ready to use. This option defines the max retry attempts to acquire the lock and execute the command in case the configuration manager is running and all commands are locked. Defaults to :infinity . Custom Keyslot As it is mentioned in the configuration options above, the :redis_cluster and :client_side_cluster modes have a default value for the :keyslot option. However, you can also provide your own implementation by implementing the Nebulex.Adapter.Keyslot and configuring the :keyslot option. For example: defmodule MyApp.ClusteredCache.Keyslot do use Nebulex.Adapter.Keyslot @impl true def hash_slot ( key , range ) do # your implementation goes here end end And the config: config :my_app , MyApp.ClusteredCache , mode : :client_side_cluster , client_side_cluster : [ keyslot : MyApp.ClusteredCache.Keyslot , nodes : [ ... ] ] NOTE: For :redis_cluster mode, the :keyslot implementation must follow the Redis cluster specification . TTL or Expiration Time As is explained in Nebulex.Cache , most of the write-like functions support the :ttl option to define the expiration time, and it is defined in milliseconds . Despite Redis work with seconds , the conversion logic is handled by the adapter transparently, so when using a cache even with the Redis adapter, be sure you pass the :ttl option in milliseconds . Data Types Currently. the adapter only works with strings, which means a given Elixir term is encoded to a binary/string before executing a command. Similarly, a returned binary from Redis after executing a command is decoded into an Elixir term. The encoding/decoding process is performed by the adapter under-the-hood. However, it is possible to provide a custom serializer via the option :serializer . The value must be module implementing the NebulexRedisAdapter.Serializer behaviour. NOTE: Support for other Redis Data Types is in the roadmap. Queryable API Since the queryable API is implemented by using KEYS command, keep in mind the following caveats: Only keys can be queried. Only strings and predefined queries are allowed as query values. Predefined queries nil - All keys are returned. {:in, [term]} - Only the keys in the given key list ( [term] ) are returned. This predefined query is only supported for Nebulex.Cache.delete_all/2 . This is the recommended way of doing bulk delete of keys. Examples iex&gt; MyApp.RedisCache . put_all ( %{ ...&gt; &quot;firstname&quot; =&gt; &quot;Albert&quot; , ...&gt; &quot;lastname&quot; =&gt; &quot;Einstein&quot; , ...&gt; &quot;age&quot; =&gt; 76 ...&gt; } ) :ok iex&gt; MyApp.RedisCache . all ( &quot;**name**&quot; ) [ &quot;firstname&quot; , &quot;lastname&quot; ] iex&gt; MyApp.RedisCache . all ( &quot;a??&quot; ) [ &quot;age&quot; ] iex&gt; MyApp.RedisCache . all ( ) [ &quot;age&quot; , &quot;firstname&quot; , &quot;lastname&quot; ] iex&gt; stream = MyApp.RedisCache . stream ( &quot;**name**&quot; ) iex&gt; stream |&gt; Enum . to_list ( ) [ &quot;firstname&quot; , &quot;lastname&quot; ] # get the values for the returned queried keys iex&gt; &quot;**name**&quot; |&gt; MyApp.RedisCache . all ( ) |&gt; MyApp.RedisCache . get_all ( ) %{ &quot;firstname&quot; =&gt; &quot;Albert&quot; , &quot;lastname&quot; =&gt; &quot;Einstein&quot; } Deleting multiple keys at once (bulk delete) iex&gt; MyApp.RedisCache . delete_all ( { :in , [ &quot;foo&quot; , &quot;bar&quot; ] } ) 2 Transactions This adapter doesn't provide support for transactions. However, in the future, it is planned support Redis Transactions by using the commands MULTI , EXEC , DISCARD and WATCH . Running Redis commands and/or pipelines Since NebulexRedisAdapter works on top of Redix and provides features like connection pools and &quot;Redis Cluster&quot; support, it may be seen also as a sort of Redis client, but it is meant to be used mainly with the Nebulex cache API. However, Redis API is quite extensive and there are a lot of useful commands we may want to run taking advantage of the NebulexRedisAdapter features. Therefore, the adapter provides two additional/extended functions to the defined cache: command!/2 and pipeline!/2 . command!(command, opts \\\\ []) iex&gt; MyCache . command! ( [ &quot;LPUSH&quot; , &quot;mylist&quot; , &quot;world&quot; ] , key : &quot;mylist&quot; ) 1 iex&gt; MyCache . command! ( [ &quot;LPUSH&quot; , &quot;mylist&quot; , &quot;hello&quot; ] , key : &quot;mylist&quot; ) 2 iex&gt; MyCache . command! ( [ &quot;LRANGE&quot; , &quot;mylist&quot; , &quot;0&quot; , &quot;-1&quot; ] , key : &quot;mylist&quot; ) [ &quot;hello&quot; , &quot;world&quot; ] pipeline!(commands, opts \\\\ []) iex&gt; [ ...&gt; [ &quot;LPUSH&quot; , &quot;mylist&quot; , &quot;world&quot; ] , ...&gt; [ &quot;LPUSH&quot; , &quot;mylist&quot; , &quot;hello&quot; ] , ...&gt; [ &quot;LRANGE&quot; , &quot;mylist&quot; , &quot;0&quot; , &quot;-1&quot; ] ...&gt; ] ...&gt; |&gt; cache . pipeline! ( key : &quot;mylist&quot; ) [ 1 , 2 , [ &quot;hello&quot; , &quot;world&quot; ] ] Options for command!/2 and pipeline!/2 : :key - It is required when used the adapter in mode :redis_cluster or :client_side_cluster so that the node where the commands will take place can be selected properly. For :standalone mode is not required (optional). :name - The name of the cache in case you are using dynamic caches, otherwise it is not required. Since these functions run on top of Redix , they also accept their options (e.g.: :timeout , and :telemetry_metadata ). See Redix docs for more information. Telemetry This adapter emits the recommended Telemetry events. See the &quot;Telemetry events&quot; section in Nebulex.Cache for more information. Adapter-specific telemetry events for the :redis_cluster mode Aside from the recommended Telemetry events by Nebulex.Cache , this adapter exposes the following Telemetry events for the :redis_cluster mode: telemetry_prefix ++ [:config_manager, :setup, :start] - This event is specific to the :redis_cluster mode. Before the configuration manager calls Redis to set up the cluster shards, this event should be invoked. The :measurements map will include the following: :system_time - The current system time in native units from calling: System.system_time() . A Telemetry :metadata map including the following fields: :adapter_meta - The adapter metadata. :pid - The configuration manager PID. telemetry_prefix ++ [:config_manager, :setup, :stop] - This event is specific to the :redis_cluster mode. After the configuration manager set up the cluster shards, this event should be invoked. The :measurements map will include the following: :duration - The time spent configuring the cluster. The measurement is given in the :native time unit. You can read more about it in the docs for System.convert_time_unit/3 . A Telemetry :metadata map including the following fields: :adapter_meta - The adapter metadata. :pid - The configuration manager PID. :status - The cluster setup status. If the cluster was configured successfully, the status will be set to :ok , otherwise, will be set to :error . :error - The status reason. When the status is :ok , the reason is :succeeded , otherwise, it is the error reason. telemetry_prefix ++ [:config_manager, :setup, :exception] - This event is specific to the :redis_cluster mode. When an exception is raised while configuring the cluster, this event should be invoked. The :measurements map will include the following: :duration - The time spent configuring the cluster. The measurement is given in the :native time unit. You can read more about it in the docs for System.convert_time_unit/3 . A Telemetry :metadata map including the following fields: :adapter_meta - The adapter metadata. :pid - The configuration manager PID. :kind - The type of the error: :error , :exit , or :throw . :reason - The reason of the error. :stacktrace - The stacktrace.","ref":"NebulexRedisAdapter.html","title":"NebulexRedisAdapter","type":"module"},{"doc":"This server takes care of initialization and cleanup jobs. For example, attaching the stats handler when the cache starts and detaching it when it terminates.","ref":"NebulexRedisAdapter.BootstrapServer.html","title":"NebulexRedisAdapter.BootstrapServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"NebulexRedisAdapter.BootstrapServer.html#child_spec/1","title":"NebulexRedisAdapter.BootstrapServer.child_spec/1","type":"function"},{"doc":"","ref":"NebulexRedisAdapter.BootstrapServer.html#start_link/1","title":"NebulexRedisAdapter.BootstrapServer.start_link/1","type":"function"},{"doc":"Default Keyslot implementation when :jchash module is loaded.","ref":"NebulexRedisAdapter.ClientCluster.Keyslot.html","title":"NebulexRedisAdapter.ClientCluster.Keyslot","type":"module"},{"doc":"Default Nebulex.Adapter.Keyslot implementation.","ref":"NebulexRedisAdapter.RedisCluster.Keyslot.html","title":"NebulexRedisAdapter.RedisCluster.Keyslot","type":"module"},{"doc":"Redis Cluster Node/Slot Supervisor.","ref":"NebulexRedisAdapter.RedisCluster.PoolSupervisor.html","title":"NebulexRedisAdapter.RedisCluster.PoolSupervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"NebulexRedisAdapter.RedisCluster.PoolSupervisor.html#child_spec/1","title":"NebulexRedisAdapter.RedisCluster.PoolSupervisor.child_spec/1","type":"function"},{"doc":"A Serializer encodes keys and values sent to Redis, and decodes keys and values in the command output. See Redis Strings .","ref":"NebulexRedisAdapter.Serializer.html","title":"NebulexRedisAdapter.Serializer","type":"behaviour"},{"doc":"Decodes key with the given opts .","ref":"NebulexRedisAdapter.Serializer.html#c:decode_key/2","title":"NebulexRedisAdapter.Serializer.decode_key/2","type":"callback"},{"doc":"Decodes value with the given opts .","ref":"NebulexRedisAdapter.Serializer.html#c:decode_value/2","title":"NebulexRedisAdapter.Serializer.decode_value/2","type":"callback"},{"doc":"Encodes key with the given opts .","ref":"NebulexRedisAdapter.Serializer.html#c:encode_key/2","title":"NebulexRedisAdapter.Serializer.encode_key/2","type":"callback"},{"doc":"Encodes value with the given opts .","ref":"NebulexRedisAdapter.Serializer.html#c:encode_value/2","title":"NebulexRedisAdapter.Serializer.encode_value/2","type":"callback"},{"doc":"Protocol controlling how a key/value is encoded to a string and how a string is decoded into an Elixir term. See Redis Strings .","ref":"NebulexRedisAdapter.Serializer.Serializable.html","title":"NebulexRedisAdapter.Serializer.Serializable","type":"protocol"},{"doc":"Decodes data with the given opts .","ref":"NebulexRedisAdapter.Serializer.Serializable.html#decode/2","title":"NebulexRedisAdapter.Serializer.Serializable.decode/2","type":"function"},{"doc":"Encodes data with the given opts .","ref":"NebulexRedisAdapter.Serializer.Serializable.html#encode/2","title":"NebulexRedisAdapter.Serializer.Serializable.encode/2","type":"function"},{"doc":"","ref":"NebulexRedisAdapter.Serializer.Serializable.html#t:t/0","title":"NebulexRedisAdapter.Serializer.Serializable.t/0","type":"type"},{"doc":"NebulexRedisAdapter error.","ref":"NebulexRedisAdapter.Error.html","title":"NebulexRedisAdapter.Error","type":"exception"},{"doc":"","ref":"NebulexRedisAdapter.Error.html#format_error/2","title":"NebulexRedisAdapter.Error.format_error/2","type":"function"},{"doc":"Error reason type","ref":"NebulexRedisAdapter.Error.html#t:reason/0","title":"NebulexRedisAdapter.Error.reason/0","type":"type"},{"doc":"Error type","ref":"NebulexRedisAdapter.Error.html#t:t/0","title":"NebulexRedisAdapter.Error.t/0","type":"type"}]